package com.idtechproducts.device.sdkdemo;

//import java.io.BufferedReader;
import java.io.File;
//import java.io.FileNotFoundException;
import java.io.FileOutputStream;
//import java.io.FileReader;
//import java.io.IOException;
import java.io.InputStream;
//import java.io.InputStreamReader;
//import java.io.OutputStreamWriter;
//import java.io.UnsupportedEncodingException;
//import java.text.SimpleDateFormat;
//import java.util.Date;
//import java.util.HashMap;
//import java.util.Iterator;
//import java.util.Locale;
//import java.util.Map;
import java.util.Set;

import com.dbconnection.dblibrarybeta.ProfileManager;
import com.dbconnection.dblibrarybeta.ProfileUtility;
//import com.idtechproducts.device.APDUResponseStruct;
import com.idtechproducts.device.Common;
import com.idtechproducts.device.ErrorCode;
import com.idtechproducts.device.ErrorCodeInfo;
//import com.idtechproducts.device.ICCReaderStatusStruct;
import com.idtechproducts.device.IDTEMVData;
import com.idtechproducts.device.IDTMSRData;
//import com.idtechproducts.device.IDT_Device;
import com.idtechproducts.device.IDT_UniMag;
//import com.idtechproducts.device.MSRSettingStruct;
import com.idtechproducts.device.OnReceiverListener;
//import com.idtechproducts.device.OnReceiverListenerPIN;
//import com.idtechproducts.device.OnReceiverListenerPINRequest;
import com.idtechproducts.device.ReaderInfo.DEVICE_TYPE;
import com.idtechproducts.device.ResDataStruct;
import com.idtechproducts.device.StructConfigParameters;
//import com.idtechproducts.device.ICCSettingStruct;
import com.idtechproducts.device.audiojack.tools.FirmwareUpdateTool;
//import com.idtechproducts.device.audiojack.tools.FirmwareUpdateToolMsg;
//import com.idtechproducts.device.bluetooth.BluetoothController;
//import com.idtechproducts.device.bluetooth.BluetoothLEController;


import android.annotation.SuppressLint;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
//import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
//import android.content.pm.PackageManager;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.support.v4.app.Fragment;
import android.support.v7.app.ActionBarActivity;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.view.WindowManager;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
//import android.widget.CheckBox;
import android.widget.EditText;
//import android.widget.ListView;
//import android.widget.RadioGroup;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;
//import android.widget.RadioGroup.OnCheckedChangeListener;


import com.dbconnection.dblibrarybeta.*;

public class UniMagSDKDemo  extends ActionBarActivity{

	private SdkDemoFragment mainView = null;
	public StructConfigParameters debugProfile;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_demo);

		if (savedInstanceState == null) {
			mainView = new SdkDemoFragment();
			getSupportFragmentManager().beginTransaction()
					.add(R.id.container, mainView).commit();
		}
		
    	getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);
	}
	
	@Override
	public void onBackPressed() {
	}
	
	
	// Inflate the menu items to the action bar
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		getMenuInflater().inflate(R.menu.main_menu, menu);
		return true;
	}
	
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch(item.getItemId()) {
		case R.id.action_switch_reader_type:
			mainView.openReaderSelectDialog();
			break;
			
		case R.id.action_start_autoconfig:
			mainView.runAutoConfig();
			break;
			
		case R.id.action_reloadxml:
			mainView.reloadXML();
			break;
			
		case R.id.action_enable_log:
			
			boolean toEnable = !item.isChecked();
			item.setChecked(toEnable);
			mainView.enableLogFeature(toEnable);
			break;
		case R.id.action_delete_log:
			mainView.deleteLogs();
			break;
			
		case R.id.action_exit_app:
			mainView.releaseSDK();
			finish();
		    System.exit(0);
			break;
		}
		return super.onOptionsItemSelected(item);
	}
	
	
	public class SdkDemoFragment extends Fragment implements OnReceiverListener, OnItemSelectedListener, RESTResponse
	{
		private IDT_UniMag device;
		private FirmwareUpdateTool fwTool;
		private static final int REQUEST_ENABLE_BT = 1;
		private long totalEMVTime;
		private boolean calcLRC = true;

		private TextView status;
		private TextView infoText;
		private TextView dataText;
		private View rootView;
		private LayoutInflater layoutInflater;
		private ViewGroup viewGroup;
		private AlertDialog alertSwipe;
		
		private String info = "";
		private String detail = "";
		private Handler handler = new Handler();

		private StructConfigParameters config = null;
		private EditText edtSelection;
		
		private Button swipeButton;
		private Button commandBtn;
		private final int emvTimeout = 30;
		
		private Dialog dlgSetTerminal;
		private Spinner spinner;
		private int spinnerSelection = 0;
		
		private boolean isFwInitDone = false;
		private byte[] tag8A = new byte[]{0x30, 0x30};
		
		static private final int REQUEST_GET_XML_FILE = 1;
		
		//// TODO: 6/2/2017 create profile manager
		private ProfileManager profileManager;
		
		private String[] commands = {
				"Get Version",  			// 0 
				"Get Serial Number", 		// 1
				"Get Setting", 				// 2
		};
		
		@Override
		public View onCreateView(LayoutInflater inflater, ViewGroup container,
				Bundle savedInstanceState) {
			layoutInflater = inflater;
			viewGroup = container;
			rootView = inflater.inflate(R.layout.fragment_main, container, false);
			
			status = (TextView)rootView.findViewById(R.id.status_text);
			status.setText("Disconnected");
			
			infoText = (TextView)rootView.findViewById(R.id.text_area_top);
			dataText = (TextView)rootView.findViewById(R.id.text_area_bottom);
			dataText.setVerticalScrollBarEnabled(true);
			
			swipeButton = (Button)rootView.findViewById(R.id.btn_swipeCard);
			swipeButton.setOnClickListener(new SwipeButtonListener());
			
			commandBtn = (Button)rootView.findViewById(R.id.btn_command);
			commandBtn.setOnClickListener(new CommandButtonListener());
			profileManager = new ProfileManager(this);
			
			return rootView;
		}
		
		@Override
		public void onActivityCreated(Bundle savedInstanceState) {
			
			if (device != null)
				device.unregisterListen();

//			initializeReader();
		    openReaderSelectDialog();
		    
			super.onActivityCreated(savedInstanceState);
		}
		
		@Override
		public void onDestroy() {
			if (device != null)
				device.unregisterListen();
			super.onDestroy();
		}

		public void initializeReader()
		{
			if (device != null){
				releaseSDK();
			}
			//IDT_Device.redirectDeviceOutput(true);
//			device = new IDT_Device(this,this,this, getActivity());
			device = new IDT_UniMag(this, getActivity());
			//com.idtechproducts.device.ProxyAction proxy = new com.idtechproducts.device.ProxyAction();
			//if (IDT_Device.getUSBBypass())  proxy.bypassUSB(device.getSDKInstance(), true);

//			device.registerListen();
			
			profileManager.doGet();
			Toast.makeText(getActivity(), "get started", Toast.LENGTH_LONG).show();
	        device.log_setVerboseLoggingEnable(true);        
//	        fwTool = new FirmwareUpdateTool(this, getActivity());
//	        fwTool.setIDT_Device(device);
	        
//	        device.setIDT_Device(fwTool);
        	displaySdkInfo();

		}
		
		void runAutoConfig() {
			config = null;
			String filepath = getXMLFileFromRaw();
	        if(!isFileExist(filepath)) {
	        	filepath = null;
	        }
			if (ErrorCode.SUCCESS == device.autoConfig_start(filepath))
				Toast.makeText(getActivity(), "AutoConfig started", Toast.LENGTH_SHORT).show();
			else 
				Toast.makeText(getActivity(), "AutoConfig not started", Toast.LENGTH_SHORT).show();
		}
		
		void reloadXML() {
			String strTmpFileName = getMyStorageFilePath();
    		if (strTmpFileName == null)
    		{
    			info = 	"Warning: Please insert SD card.";
    			detail = "";
    			handler.post(doUpdateStatus);
    			return;
    		}
        	FileDialog fileDialog = new FileDialog();
        	Intent intent = new Intent(getActivity(), fileDialog.getClass());
			intent.putExtra(FileDialog.START_PATH, Environment.getExternalStorageDirectory().getPath());
			startActivityForResult(intent, REQUEST_GET_XML_FILE);
		}
		
		public synchronized void onActivityResult(final int requestCode, int resultCode, final Intent data) {

	        if (resultCode == Activity.RESULT_OK) {

	        	String strTmpFileName = data.getStringExtra(FileDialog.RESULT_PATH);;
	            if (requestCode == REQUEST_GET_XML_FILE) {
		    		
		    		if(!isFileExist(strTmpFileName))
		    		{ 
		    			info = 	"Warning: Please copy the XML file 'IDT_uniMagCfg.xml' into root path of SD card.";
		    			detail = "";
		    			handler.post(doUpdateStatus);
		    			return  ;
		    		}
		    		if (!strTmpFileName.endsWith(".xml")){
		    			info = 	"Warning: Please select a file with .xml file extension.";
		    			detail = "";
		    			handler.post(doUpdateStatus);
		    			return  ;
		    		}
		    		
		    		/////////////////////////////////////////////////////////////////////////////////
		    		// loadingConfigurationXMLFile() method may connect to server to download xml file.
		    		// Network operation is prohibited in the UI Thread if target API is 11 or above.
		    		// If target API is 11 or above, please use AsyncTask to avoid errors.
		    		device.config_setXMLFileNameWithPath(strTmpFileName);
		    	    if (device.config_loadingConfigurationXMLFile(false)) {
			    	    info = 	"Command Info: Reload XML file succeeded.";
		    			detail = "";
		    			handler.post(doUpdateStatus);
		    	    }
		    	    else {
		    			info = 	"Warning: Please select a correct file and try again.";
		    			detail = "";
		    			handler.post(doUpdateStatus);
		    	    }
	            }
	        } 
	    }
		
		 private String getMyStorageFilePath( ) {
			String path = null;
			if(isStorageExist())
				path = Environment.getExternalStorageDirectory().toString();
			return path;
		}
//		private boolean isFileExist(String path) {
//	    	if(path==null)
//	    		return false;
//		    File file = new File(path);
//		    if (!file.exists()) {
//		      return false ;
//		    }
//		    return true;
//	    }
		 private boolean isStorageExist() {
			//if the SD card exists
			boolean sdCardExist = Environment.getExternalStorageState().equals(android.os.Environment.MEDIA_MOUNTED);
			return sdCardExist;
		}
	    
	    void openReaderSelectDialog() {
			initializeReader();
	    	AlertDialog.Builder builder = new AlertDialog.Builder(getActivity());
	    	builder.setTitle("Select a device:");
	    	builder.setCancelable(false);
	    	builder.setItems(R.array.reader_type, new DialogInterface.OnClickListener() {
				
				public void onClick(DialogInterface dialog, int which) {
					switch(which) {

					case 0:
						if (device.device_setDeviceType(DEVICE_TYPE.DEVICE_UNIMAG_PRO))
						{
//							device.setIDT_Device(fwTool);
							Toast.makeText(getActivity(), "UniMag Pro is selected", Toast.LENGTH_SHORT).show();
						}
						else 
							Toast.makeText(getActivity(), "Failed. Please disconnect first.", Toast.LENGTH_SHORT).show();
						break;
					case 1:
						if (device.device_setDeviceType(DEVICE_TYPE.DEVICE_UNIMAG))
						{
//							device.setIDT_Device(fwTool);
							Toast.makeText(getActivity(), "UniMag is selected", Toast.LENGTH_SHORT).show();
						}
						else 
							Toast.makeText(getActivity(), "Failed. Please disconnect first.", Toast.LENGTH_SHORT).show();
						break;
					}
					device.registerListen();
				}
			});
	    	builder.create().show();
	    }
		
		Dialog dlgMenu;
		Dialog dlgLanguageMenu;
		byte type;
		String[] theLines;
		byte[] Language;
		byte MessageId;
		int finalTimout;
		public void lcdDisplay(int mode, String[] lines, int timeout) {
//			type = (byte) mode;
//			theLines = lines;
//			finalTimout = timeout;
//			getActivity().runOnUiThread(new Runnable() {			
//				 public void run() {
//					if (type == 0x01) //Application Menu Display
//					{
//						dlgMenu = new Dialog(getActivity());
//						dlgMenu.setTitle("Application Menu");
//						dlgMenu.setCancelable(false);
//						dlgMenu.setContentView(R.layout.emv_menu_display_dialog);
//						TextView tv = new TextView(getActivity());
//						tv = (TextView) dlgMenu.findViewById(R.id.tvApplication);
//						String strApplication = "";
//						for (int x = 0; x < theLines.length; x++){
//							strApplication = (strApplication + theLines[x] + "\r\n");
//						}
//						tv.setText(strApplication);
//						
//						edtSelection = (EditText) dlgMenu.findViewById(R.id.edtAppSelection);
//						
//						Button btnMenuDisplayOK = (Button) dlgMenu.findViewById(R.id.btnMenuDisplayOK);
//						btnMenuDisplayOK.setOnClickListener(menuDisplayOKOnClick);
//						dlgMenu.show();
//						
//						//wait for timeout
//						dialogId = 3;
//						timerDelayRemoveDialog((long)finalTimout * 1000, dlgMenu);
//					}
//					else if (type == 0x02) //Normal Display Get Function Key
//					{
//						
//					}
//					else if (type == 0x08) //Language Menu Display
//					{
//						//Open a language menu
//						dlgLanguageMenu = new Dialog(getActivity());
//						dlgLanguageMenu.setContentView(R.layout.language_menu);
//		
//						final ListView lv = (ListView ) dlgLanguageMenu.findViewById(R.id.lvLanguage);
//		
//						final int[] lineNum = new int[theLines.length];
//						
//						for (int i=0;i<theLines.length;i++)
//						{
//							lineNum[i] = Integer.valueOf(theLines[i].substring(0, 1))  ;
//						}
//						
//						ArrayAdapter<String> adapter = new ArrayAdapter<String>(getActivity(), R.layout.single_row_textview, 
//								   R.id.tvLanguage, theLines);
//				
//				        lv.setAdapter(adapter);
//				        
//				        lv.setOnItemClickListener(new AdapterView.OnItemClickListener() {       
//					        public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
//					        	device.emv_lcdControlResponse((byte)0x08, (byte)(lineNum[position] & 0xFF));
//					        	dlgLanguageMenu.dismiss();
//					        }
//					    });
//				        
//						dlgLanguageMenu.setCancelable(false);
//						dlgLanguageMenu.setTitle("Select Language");
//						dlgLanguageMenu.show();
//		
//						//wait for timeout
//						dialogId = 2;
//						timerDelayRemoveDialog((long)finalTimout * 1000, dlgLanguageMenu);
//					}
//					else{
////						ResDataStruct toData = new ResDataStruct();
//						info = theLines[0];
//						handler.post(doUpdateStatus);
//					}
//				 }
//			});
		}
		
		public void lcdDisplay(int mode, String[] lines, int timeout, byte[] languageCode, byte messageId) {
//			type = (byte) mode;
//			theLines = lines;
//			finalTimout = timeout;
//			Language = languageCode;
//			MessageId = messageId;
//			getActivity().runOnUiThread(new Runnable() {			
//				 public void run() {
//					if (type == 0x01) //Application Menu Display
//					{
//						dlgMenu = new Dialog(getActivity());
//						dlgMenu.setTitle("Application Menu");
//						dlgMenu.setCancelable(false);
//						dlgMenu.setContentView(R.layout.emv_menu_display_dialog);
//						TextView tv = new TextView(getActivity());
//						tv = (TextView) dlgMenu.findViewById(R.id.tvApplication);
//						String strApplication = "";
//						for (int x = 0; x < theLines.length; x++){
//							strApplication = (strApplication + theLines[x] + "\r\n");
//						}
//						tv.setText(strApplication);
//						
//						edtSelection = (EditText) dlgMenu.findViewById(R.id.edtAppSelection);
//						
//						Button btnMenuDisplayOK = (Button) dlgMenu.findViewById(R.id.btnMenuDisplayOK);
//						btnMenuDisplayOK.setOnClickListener(menuDisplayOKOnClick);
//						dlgMenu.show();
//						
//						//wait for timeout
//						dialogId = 3;
//						timerDelayRemoveDialog((long)finalTimout * 1000, dlgMenu);
//					}
//					else if (type == 0x02) //Normal Display Get Function Key
//					{
//						
//					}
//					else if (type == 0x08) //Language Menu Display
//					{
//						//Open a language menu
//						dlgLanguageMenu = new Dialog(getActivity());
//						dlgLanguageMenu.setContentView(R.layout.language_menu);
//		
//						final ListView lv = (ListView ) dlgLanguageMenu.findViewById(R.id.lvLanguage);
//		
//						final int[] lineNum = new int[theLines.length];
//						
//						for (int i=0;i<theLines.length;i++)
//						{
//							lineNum[i] = Integer.valueOf(theLines[i].substring(0, 1))  ;
//						}
//						
//						ArrayAdapter<String> adapter = new ArrayAdapter<String>(getActivity(), R.layout.single_row_textview, 
//								   R.id.tvLanguage, theLines);
//				
//				        lv.setAdapter(adapter);
//				        
//				        lv.setOnItemClickListener(new AdapterView.OnItemClickListener() {       
//					        public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
//					        	device.emv_lcdControlResponse((byte)0x08, (byte)(lineNum[position] & 0xFF));
//					        	dlgLanguageMenu.dismiss();
//					        }
//					    });
//				        
//						dlgLanguageMenu.setCancelable(false);
//						dlgLanguageMenu.setTitle("Select Language");
//						dlgLanguageMenu.show();
//		
//						//wait for timeout
//						dialogId = 2;
//						timerDelayRemoveDialog((long)finalTimout * 1000, dlgLanguageMenu);
//					}
//					else{
////						ResDataStruct toData = new ResDataStruct();
////						String message = Common.getLCDMessage(Language, MessageId);
//						info = theLines[0];
//						handler.post(doUpdateStatus);
//					}
//				 }
//			});
		}
		
		

		
//		private View.OnClickListener menuDisplayOKOnClick = new View.OnClickListener(){
//			public void onClick(View v){
//				
//				byte bSelection = Byte.parseByte(edtSelection.getText().toString());
//				if (bSelection == 0x00)
//				{
//					Toast.makeText(getActivity(),"Selection Error: Cannot be 0",Toast.LENGTH_LONG).show();
//					return;
//				}
//				device.emv_lcdControlResponse((byte)0x01, (byte)bSelection);
//				dlgMenu.dismiss();
//				
//				
//			}
//		};
		
//		private View.OnClickListener menuDisplayCancelOnClick = new View.OnClickListener(){
//			public void onClick(View v){
//				if (device.device_getDeviceType() == DEVICE_TYPE.DEVICE_MINISMART_II || device.device_getDeviceType() == DEVICE_TYPE.DEVICE_AUGUSTA)
//				{
//					ResDataStruct resData = new ResDataStruct();
//					device.emv_cancelEMVTransaction(resData); //emv cancel transaction
//					dlgMenu.dismiss();
//					info = "EMV Transaction Cancelled";
//					handler.post(doUpdateStatus);
//				}
//			}
//		};
		
/*
		public void connectReader() {
			if (config != null) {
				if (!device.device_connectWithProfile(config)) {
					info = "SDK could not connect a reader...";
					detail = "";
					handler.post(doUpdateStatus);
				}
				else {
					info = "Connecting...";
					detail = "";
					handler.post(doUpdateStatus);
				}
			}
			
			else if (device != null) {
			
				if (!device.device_connect()){
					info = "SDK could not connect a reader...";
					detail = "";
					handler.post(doUpdateStatus);
				}
				else {
					info = "Connecting...";
					detail = "";
					handler.post(doUpdateStatus);
				}
			}
			else {
				info = "SDK could not connect a reader...";
				detail = "";
				handler.post(doUpdateStatus);
			}
		}
*/
		public void releaseSDK() {
			if (device != null) {
				device.unregisterListen();
				device.release();
			}			
		}

		public void enableLogFeature (boolean enable) {
			if (device != null) {
//				device.log_setVerboseLoggingEnable(enable);
				device.log_setSaveLogEnable(enable);
			}
			
			if (enable)
				Toast.makeText(getActivity(), "Log feature enabled", Toast.LENGTH_SHORT).show();
			else 
				Toast.makeText(getActivity(), "Log feature disabled", Toast.LENGTH_SHORT).show();
		}
		
		public void deleteLogs()
		{
			if (device != null) {
				int fileDeleted = device.log_deleteLogs();
				Toast.makeText(getActivity(), "Total of "+fileDeleted+" files are deleted.", Toast.LENGTH_SHORT).show();
			}
		}
		
		public void displaySdkInfo() {
			
			info = 	"Manufacturer: " + android.os.Build.MANUFACTURER + "\n" + 
					"Model: " + android.os.Build.MODEL + "\n" + 
					"OS Version: " + android.os.Build.VERSION.RELEASE + " \n" +
					"SDK Version: \n" + device.config_getSDKVersion() + "\n";
			
			detail = "";
			
			handler.post(doUpdateStatus);
		}
		
		private Runnable doUpdateStatus = new Runnable()
		{
			public void run()
			{		
				infoText.setText(info);
				dataText.setText(detail);
			}
		};
		private Runnable doSwipeProgressBar = new Runnable() {

			public void run() {
				if (startSwipe)
				{
					AlertDialog.Builder builder = new AlertDialog.Builder(getActivity());
					builder.setTitle("Please swipe/tap a card");
					builder.setView(layoutInflater.inflate(R.layout.frame_swipe, viewGroup, false));
					builder.setCancelable(false);
					builder.setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
						
						public void onClick(DialogInterface dialog, int which) {
//							int ret = device.msr_cancelMSRSwipe();
							device.msr_cancelMSRSwipe();
//							if (ret == ErrorCode.SUCCESS){
//								infoText.setText("Swipe cancelled");
//							}
//							else {
//								infoText.setText("Failed to cancel swipe");
//							}
							swipeButton.setEnabled(true);
							commandBtn.setEnabled(true);
						}
					});
					alertSwipe = builder.create();
					alertSwipe.show();
				}
			}
			
		};
		
		private boolean startSwipe = false;
		private class SwipeButtonListener implements OnClickListener {
			public void onClick(View arg0) {			
				startSwipe = true;
				int ret = device.msr_startMSRSwipe();
				
				swipeButton.setEnabled(false);
				commandBtn.setEnabled(false);
				
				if (ret == ErrorCode.SUCCESS) {
					info = "Please swipe/tap a card";
					detail = "";
					handler.post(doSwipeProgressBar);
					handler.post(doUpdateStatus);
				}
				else if (ret == ErrorCode.RETURN_CODE_OK_NEXT_COMMAND)
				{
					info = "Start EMV transaction\n";
					detail = "";
					handler.post(doUpdateStatus);
				}
				else {
					info = "cannot swipe/tap card\n";
					info += "Status: "+device.device_getResponseCodeString(ret)+"";
					detail = "";
					swipeButton.setEnabled(true);
					commandBtn.setEnabled(true);
					handler.post(doUpdateStatus);
				}
			}
		}
		private class CommandButtonListener implements OnClickListener{

			private Dialog dlgStartEMV;
			private EditText edtAmount;
			private EditText edt8A;
			private Dialog dlgAID;
			private Dialog dlgCAPK;
			private Dialog dlgCRL;
			private Dialog dlgTerminal;
//			private Dialog dlgSetTerminal;
			private Dialog dlgSendCAPDU;
			private Dialog dlgSendCmd;
			private Dialog dlgCTLSTrans;
			private EditText edtCAPDU;
			private EditText edtCmd;
			private EditText edtSubCmd;
			private EditText edtCmdData;
			private String strAPDU;
			private String _first_strAPDU="00A404000E315041592E5359532E444446303100";
//			private boolean encryptedAPDU = false;
			private boolean isContactless = false;

			public void onClick(View v) {
				final ArrayAdapter<String> arrayAdapter = new ArrayAdapter<String>(
	                    getActivity(), R.layout.command_dialog, commands);//getActivity().getResources().getStringArray(R.array.commands));
				AlertDialog.Builder commandBuilder = new AlertDialog.Builder(getActivity());
				commandBuilder.setTitle("Select a Command");
				commandBuilder.setAdapter(arrayAdapter, new DialogInterface.OnClickListener () {

					@SuppressLint("SimpleDateFormat")
					public void onClick(DialogInterface dialog, int which) {
						if (device == null)
							return;

						StringBuilder sb = new StringBuilder();
						int ret;
						ResDataStruct resData = new ResDataStruct();
						String strData;
						String DisplayMsgSig;
						byte[] DisplayMsgSigData;
						switch (which) {
						case 0:
							ret = device.device_getFirmwareVersion(sb);
							if (ret == ErrorCode.SUCCESS) {
								info = "Firmware Version: " + sb.toString();
							}
							else {
								info = "GetFirmwareVersion: Failed\n";
								info += "Status: "+device.device_getResponseCodeString(ret)+"";
							}
							detail = "";
							handler.post(doUpdateStatus);
							break;
						case 1:
							ret = device.config_getSerialNumber(sb);
							if (ret == ErrorCode.SUCCESS) {
								info = "Serial Number: " + sb.toString();
							}
							else {
								info = "GetSerialNumber: Failed\n";
								info += "Status: "+device.device_getResponseCodeString(ret)+"";
							}
							detail = "";
							handler.post(doUpdateStatus);
							break;
						case 2:
							ret = device.device_ReviewAudioJackSetting(resData); 
							if (ret == ErrorCode.SUCCESS) {
								info = "Review AudioJack Settings: <" + Common.base16Encode(resData.resData)+">";
								detail = "";
								handler.post(doUpdateStatus);
							}
							else {
								info = "review AudioJack Settings: Failed\n";
								info += "Status: "+device.device_getResponseCodeString(ret)+"";
								detail = "";
								handler.post(doUpdateStatus);							
							}
							break;
						}
					}
					
				});
				
				commandBuilder.setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
					
					public void onClick(DialogInterface dialog, int which) {
					}
				});
				commandBuilder.create().show();				
			}
		}
		
		private void printTags(IDTEMVData emvData)
		{
			if (emvData.result == IDTEMVData.START_TRANS_SUCCESS)
//				detail += "Start transaction response:\r\n";
				detail = "Start transaction response:\r\n";
			else if (emvData.result == IDTEMVData.GO_ONLINE)
				detail += "\r\nAuthentication response:\r\n";
			else if (emvData.result == IDTEMVData.USE_MAGSTRIPE || emvData.result == IDTEMVData.MSR_SUCCESS)
			{
//				detail += "MSR Fallback response:\r\n";
				swipeMSRData(emvData.msr_cardData);
				detail += "\r\n\r\n";
				detail += this.emvErrorCodes(emvData.result) + "\r\n";
				return;
//				IDTMSRData card = emvData.msr_cardData;
//				if (card.result != ErrorCode.SUCCESS)
//				{
//					info += "\r\nMSR card data didn't read correctly\n";
//					info += ErrorCodeInfo.getErrorCodeDescription(card.result);
//					if (card.result != ErrorCode.FAILED_NACK)
//					{
//						handler.post(doUpdateStatus);
//						return;
//					}
//				}
//				else
//				{
//					info += "\r\nMSR Card tapped/Swiped Successfully";
//				}
//				if (device.device_getDeviceType() == DEVICE_TYPE.DEVICE_UNIPAY_III || device.device_getDeviceType() == DEVICE_TYPE.DEVICE_UNIPAY_III_USB ||
//						device.device_getDeviceType() == DEVICE_TYPE.DEVICE_UNIPAY_I_V || device.device_getDeviceType() == DEVICE_TYPE.DEVICE_UNIPAY_I_V_USB ||
//						device.device_getDeviceType() == DEVICE_TYPE.DEVICE_BTPAY || device.device_getDeviceType() == DEVICE_TYPE.DEVICE_BTPAY_USB ||
//						device.device_getDeviceType() == DEVICE_TYPE.DEVICE_KIOSK_III || device.device_getDeviceType() == DEVICE_TYPE.DEVICE_VENDI ||
//						device.device_getDeviceType() == DEVICE_TYPE.DEVICE_VP4880 || device.device_getDeviceType() == DEVICE_TYPE.DEVICE_UNIPAY_III_BT)
//				{
//					detail += Common.parse_MSRData(device.device_getDeviceType(), card);
//				}
//				else if (device.device_getDeviceType() == DEVICE_TYPE.DEVICE_AUGUSTA)
//				{
//					if (card.encTrack1 != null || card.encTrack2 != null || card.encTrack3 != null)
//					{
//						detail += Common.parse_MSRData(device.device_getDeviceType(), card);
//					}
//					else
//					{
//						detail += "Flag Byte: "+Common.base16Encode(new byte[] {card.cardDataFlag})+"\nCardData:\n"+Common.base16Encode(card.cardData)+"\n";
//						detail += "track1 decode status: "+Common.base16Encode(new byte[] {card.t1DecodeStatus})+"\ntrack1: "+Common.base16Encode(card.encTrack1)+"\n"+card.track1+
//								"\n\ntrack2 decode status: "+Common.base16Encode(new byte[] {card.t2DecodeStatus})+"\ntrack2: "+Common.base16Encode(card.encTrack2)+"\n"+card.track2+
//								"\n\ntrack3 decode status: "+Common.base16Encode(new byte[] {card.t1DecodeStatus})+"\ntrack3: "+Common.base16Encode(card.encTrack3)+"\n"+card.track3;
//					}
//				}
//				else
//				{
//					detail += "Flag Byte: "+Common.base16Encode(new byte[] {card.cardDataFlag})+"\nCardData:\n"+Common.base16Encode(card.cardData)+"\n";
//					detail += "track1: "+card.track1+"\ntrack2: "+card.track2+"\ntrack3: "+card.track3;
//				}
//				detail += "\r\nAuthentication response:\r\n";
//				return;
			}
			else 
				detail += "\r\nComplete Transaction response:\r\n";
			if (emvData.unencryptedTags != null && !emvData.unencryptedTags.isEmpty())
			{
				detail += "Unencrypted Tags:\r\n";
				Set<String> keys = emvData.unencryptedTags.keySet();
				for(String key: keys){
					detail += key + ": ";
					byte[] data = emvData.unencryptedTags.get(key);
					detail += Common.getHexStringFromBytes(data) + "\r\n";
				}
			}
			if (emvData.maskedTags != null && !emvData.maskedTags.isEmpty())
			{
				detail += "Masked Tags:\r\n";
				Set<String> keys = emvData.maskedTags.keySet();
				for(String key: keys){
					detail += key + ": ";
					byte[] data = emvData.maskedTags.get(key);
					detail += Common.getHexStringFromBytes(data) + "\r\n";
				}
			}
			if (emvData.encryptedTags != null && !emvData.encryptedTags.isEmpty())
			{
				detail += "Encrypted Tags:\r\n";
				Set<String> keys = emvData.encryptedTags.keySet();
				for(String key: keys){
					detail += key + ": ";
					byte[] data = emvData.encryptedTags.get(key);
					detail += Common.getHexStringFromBytes(data) + "\r\n";
				}
			}
			detail += this.emvErrorCodes(emvData.result) + "\r\n";
		}
		
		////////////// CALLBACKS /////////////
		public void deviceConnected() {
			
			getActivity().runOnUiThread(new Runnable() {
				public void run() {
			
			status.setText("Connected");
			if (!Common.getBootLoaderMode())
			{
				info = "Reader is connected\r\n";
//				if (info.startsWith("UNIPAY_III_BT"))
//					info += "Address: " + btleDeviceAddress;
				detail = "";
				handler.post(doUpdateStatus);
			}
			Toast.makeText(getActivity(), "Reader Connected", Toast.LENGTH_LONG).show();
			
				}
			});
			
		}
	
		public void deviceDisconnected() {
			
			getActivity().runOnUiThread(new Runnable() {
				public void run() {
			
			if (alertSwipe != null)
				if (alertSwipe.isShowing())
					alertSwipe.dismiss();
			status.setText("Disconnected");
			swipeButton.setEnabled(true);
			commandBtn.setEnabled(true);
			if (!Common.getBootLoaderMode())
			{
				info = "Reader is disconnected";
				detail = "";
				handler.post(doUpdateStatus);
			}
			
				}
			});
		}

		public void timeout(int errorCode) {
			if (alertSwipe != null && alertSwipe.isShowing())
				alertSwipe.dismiss();
			info = ErrorCodeInfo.getErrorCodeDescription(errorCode);
			detail = "";
			handler.post(doUpdateStatus);
//			if (errorCode == ErrorCode.TIMEOUT_CONNECTION)
//			{
//				ResDataStruct resData = new ResDataStruct();
//				device.emv_cancelTransaction(resData);
//			}
			swipeButton.setEnabled(true);
			commandBtn.setEnabled(true);
		}
		
		public void autoConfigCompleted(final StructConfigParameters profile) {
			getActivity().runOnUiThread(new Runnable() {
				public void run() {
					Toast.makeText(getActivity(), "AutoConfig found a working profile.", Toast.LENGTH_LONG).show();
		            profileManager.doPost(profile);
					if(device.device_connectWithProfile(profile)){
						Toast.makeText(getActivity(), "worked", Toast.LENGTH_SHORT).show();
					}else{
		                Toast.makeText(getActivity(), "didnt work", Toast.LENGTH_SHORT).show();
		            }
				}
			});

		}

		public void autoConfigProgress(final int progressValue) {
			getActivity().runOnUiThread(new Runnable() {
				public void run() {
					info = "AutoConfig is running: "+progressValue +"%";
					detail = "";
					handler.post(doUpdateStatus);
				}
			});
		}

		public void ICCNotifyInfo(byte[] dataNotify, String strMessage) {
			if(strMessage!=null && strMessage.length()>0)
			{
				String strHexResp = Common.getHexStringFromBytes(dataNotify);
		 		Log.d("Demo Info >>>>>","dataNotify="+ strHexResp);
	
				info = "ICC Notification Info: "+strMessage+"\n"+"Resp: "+strHexResp;
				detail="";
				handler.post(doUpdateStatus);
			}
		}

		public void msgToConnectDevice() {
			info = "Connecting a reader...";
			detail = "";
			handler.post(doUpdateStatus);
		}

		public void msgAudioVolumeAjustFailed() {
			info = "SDK could not adjust volume...";
			detail = "";
			handler.post(doUpdateStatus);			
		}
		
		public void LoadXMLConfigFailureInfo(int index, String strMessage) {
			info = "XML loading error...";
			detail = "";
			handler.post(doUpdateStatus);
			
		}
		
	    private boolean isFileExist(String path) {
	    	if(path==null)
	    		return false;
		    File file = new File(path);
		    if (!file.exists()) {
		      return false ;
		    }
		    return true;
	    }  

		private String getXMLFileFromRaw(){
			//the target filename in the application path
	       String fileName = "idt_unimagcfg_default.xml";
		
	       try{
	    	   InputStream in = getResources().openRawResource(R.raw.idt_unimagcfg_default);
	    	   int length = in.available();
	    	   byte [] buffer = new byte[length];
	    	   in.read(buffer);    	   
	    	   in.close();
	    	   getActivity().deleteFile(fileName);
	    	   FileOutputStream fout = getActivity().openFileOutput(fileName, MODE_PRIVATE);
	    	   fout.write(buffer);
	    	   fout.close();
	    	   
	    	   // to refer to the application path
		       File fileDir = getActivity().getFilesDir();
		       fileName = fileDir.getParent() + java.io.File.separator + fileDir.getName();
		       fileName = fileName+java.io.File.separator+"idt_unimagcfg_default.xml";
		   	   
	       } catch(Exception e){
	    		   e.printStackTrace();
	    		   fileName = null;
	       }
	       return   fileName;
		}

		public void onReceiveMsgChallengeResult(int returnCode, byte[] data) {
			// Not called for UniPay Firmware update
		}

		public void msgRKICompleted(String MACResult) {
			info = "Remote Key Injection Succeeded\nMac result: 0x"+MACResult;
			detail = "";
			handler.post(doUpdateStatus);
		}
		
		public void dataInOutMonitor(byte[] data, boolean isIncoming) {
			
		}

		public void emvTransactionData(IDTEMVData emvData) {

		}
		
		IDTMSRData msr_card;
		//Callback function for MSR swipe
		public void swipeMSRData(IDTMSRData card) {
			msr_card = card;
			
			getActivity().runOnUiThread(new Runnable() {
				 public void run() {
			
			startSwipe = false;
			if (alertSwipe != null)
				alertSwipe.dismiss();
			
			if (msr_card.result != ErrorCode.SUCCESS)
			{
				info = "MSR card data didn't read correctly\n";
				info += ErrorCodeInfo.getErrorCodeDescription(msr_card.result);
				if (msr_card.result != ErrorCode.FAILED_NACK)
				{
					detail = "";
					swipeButton.setEnabled(true);
					commandBtn.setEnabled(true);
					handler.post(doUpdateStatus);
					return;
				}
			}
			else
			{
				info = "MSR Card Swiped Successfully";
			}
			detail = "Flag Byte: "+Common.base16Encode(new byte[] {msr_card.cardDataFlag})+"\nCardData:\n"+Common.base16Encode(msr_card.cardData)+"\n";
			detail += "track1: "+msr_card.track1+"\ntrack2: "+msr_card.track2+"\ntrack3: "+msr_card.track3;
			swipeButton.setEnabled(true);
			commandBtn.setEnabled(true);
			handler.post(doUpdateStatus);
			
				 }
				 
			 });
		}
		
		public void onReceiveMsgUpdateFirmwareProgress(int nProgressValue) {
//			if (Common.getBootLoaderMode())
//			{
//				info = "Firmware update is in process... ("+nProgressValue+"%)";
////				detail = "";
//			}
//			else
//			{
//				info = "Firmware update initialization is in process...";
//			}
//			handler.post(doUpdateStatus);
		}		
		
		public void onReceiveMsgUpdateFirmwareResult(final int result) {
//			getActivity().runOnUiThread(new Runnable() {
//				 public void run() {
//					 switch (result) {
//						case FirmwareUpdateToolMsg.cmdUpdateFirmware_Succeed:
//							info = "Firmware update is done successfully...";
//							detail = "";
//							isFwInitDone = false;
//							break;
//						case FirmwareUpdateToolMsg.cmdInitializeUpdateFirmware_Succeed:
//							if (device.device_getDeviceType() == DEVICE_TYPE.DEVICE_KIOSK_III)
//								info = "Firmware update initialization is done successfully, please wait for device reconnection and do firmware update.";
//							else
//								info = "Firmware update initialization is done successfully, please do firmware update now.";
//							isFwInitDone = true;
////							detail = "";
//							break;
//						case FirmwareUpdateToolMsg.cmdUpdateFirmware_Timeout:
//							if (Common.getBootLoaderMode())
//							{
//								info = "Firmware update timeout... Please try firmware update again...";
//								detail = "";
//							}
//							else
//							{
//								info = "Firmware update initialization timeout... Please try again...";
//							}
//							break;
//						case FirmwareUpdateToolMsg.cmdUpdateFirmware_DownloadBlockFailed:
//							info = "Firmware update failed... Please try again...";
//							detail = "";
//							
//							break;
//						}
//
//						swipeButton.setEnabled(true);
//						commandBtn.setEnabled(true);
//						handler.post(doUpdateStatus);
//						
//				 }
//				 
//				 });
		}
		
		public void pinpadData(final byte[] data){
//			getActivity().runOnUiThread(new Runnable() {
//				 public void run() {
//					detail = "";
//					info = "PIN data:\n"+Common.base16Encode(data);
//					swipeButton.setEnabled(true);
//					commandBtn.setEnabled(true);
//					handler.post(doUpdateStatus);
//				}
//			});
		}
		
		private String emvErrorCodes(int val){
//			if (val ==IDTEMVData.APPROVED_OFFLINE) return "APPROVED_OFFLINE";
//			if (val ==IDTEMVData.DECLINED_OFFLINE) return "DECLINED_OFFLINE";
//			if (val ==IDTEMVData.APPROVED) return "APPROVED";
//			if (val ==IDTEMVData.DECLINED) return "DECLINED";
//		    if (val ==IDTEMVData.GO_ONLINE) return "GO_ONLINE";
//		    if (val ==IDTEMVData.CALL_YOUR_BANK) return "CALL_YOUR_BANK";
//		    if (val ==IDTEMVData.NOT_ACCEPTED) return "NOT_ACCEPTED";
//		    if (val ==IDTEMVData.USE_MAGSTRIPE) return "USE_MAGSTRIPE";
//		    if (val ==IDTEMVData.TIME_OUT) return "TIME_OUT";
//		    if (val ==IDTEMVData.START_TRANS_SUCCESS) return "START_TRANS_SUCCESS";
//		    if (val ==IDTEMVData.MSR_SUCCESS) return "MSR_SUCCESS";
//		    if (val ==IDTEMVData.FILE_ARG_INVALID) return "FILE_ARG_INVALID";
//		    if (val ==IDTEMVData.FILE_OPEN_FAILED) return "FILE_OPEN_FAILED";
//		    if (val ==IDTEMVData.FILE_OPERATION_FAILED) return "FILE_OPERATION_FAILED";
//		    if (val ==IDTEMVData.MEMORY_NOT_ENOUGH) return "MEMORY_NOT_ENOUGH";
//		    if (val ==IDTEMVData.SMARTCARD_FAIL) return "SMARTCARD_FAIL";
//		    if (val ==IDTEMVData.SMARTCARD_INIT_FAILED) return "SMARTCARD_INIT_FAILED";
//		    if (val ==IDTEMVData.FALLBACK_SITUATION) return "FALLBACK_SITUATION";
//		    if (val ==IDTEMVData.SMARTCARD_ABSENT) return "SMARTCARD_ABSENT";
//		    if (val ==IDTEMVData.SMARTCARD_TIMEOUT) return "SMARTCARD_TIMEOUT";
//		    if (val ==IDTEMVData.MSR_CARD_ERROR) return "MSR_CARD_ERROR";
//		    if (val ==IDTEMVData.PARSING_TAGS_FAILED) return "PARSING_TAGS_FAILED";
//		    if (val ==IDTEMVData.CARD_DATA_ELEMENT_DUPLICATE) return "CARD_DATA_ELEMENT_DUPLICATE";
//		    if (val ==IDTEMVData.DATA_FORMAT_INCORRECT) return "DATA_FORMAT_INCORRECT";
//		    if (val ==IDTEMVData.APP_NO_TERM) return "APP_NO_TERM";
//		    if (val ==IDTEMVData.APP_NO_MATCHING) return "APP_NO_MATCHING";
//		    if (val ==IDTEMVData.AMANDATORY_OBJECT_MISSING) return "AMANDATORY_OBJECT_MISSING";
//		    if (val ==IDTEMVData.APP_SELECTION_RETRY) return "APP_SELECTION_RETRY";
//		    if (val ==IDTEMVData.AMOUNT_ERROR_GET) return "AMOUNT_ERROR_GET";
//		    if (val ==IDTEMVData.CARD_REJECTED) return "CARD_REJECTED";
//		    if (val ==IDTEMVData.AIP_NOT_RECEIVED) return "AIP_NOT_RECEIVED";
//		    if (val ==IDTEMVData.AFL_NOT_RECEIVEDE) return "AFL_NOT_RECEIVEDE";
//		    if (val ==IDTEMVData.AFL_LEN_OUT_OF_RANGE) return "AFL_LEN_OUT_OF_RANGE";
//		    if (val ==IDTEMVData.SFI_OUT_OF_RANGE) return "SFI_OUT_OF_RANGE";
//		    if (val ==IDTEMVData.AFL_INCORRECT) return "AFL_INCORRECT";
//		    if (val ==IDTEMVData.EXP_DATE_INCORRECT) return "EXP_DATE_INCORRECT";
//		    if (val ==IDTEMVData.EFF_DATE_INCORRECT) return "EFF_DATE_INCORRECT";
//		    if (val ==IDTEMVData.ISS_COD_TBL_OUT_OF_RANGE) return "ISS_COD_TBL_OUT_OF_RANGE";
//		    if (val ==IDTEMVData.CRYPTOGRAM_TYPE_INCORRECT) return "CRYPTOGRAM_TYPE_INCORRECT";
//		    if (val ==IDTEMVData.PSE_BY_CARD_NOT_SUPPORTED) return "PSE_BY_CARD_NOT_SUPPORTED";
//		    if (val ==IDTEMVData.USER_LANGUAGE_SELECTED) return "USER_LANGUAGE_SELECTED";
//		    if (val ==IDTEMVData.SERVICE_NOT_ALLOWED) return "SERVICE_NOT_ALLOWED";
//		    if (val ==IDTEMVData.NO_TAG_FOUND) return "NO_TAG_FOUND";
//		    if (val ==IDTEMVData.CARD_BLOCKED) return "CARD_BLOCKED";
//		    if (val ==IDTEMVData.LEN_INCORRECT) return "LEN_INCORRECT";
//		    if (val ==IDTEMVData.CARD_COM_ERROR) return "CARD_COM_ERROR";
//		    if (val ==IDTEMVData.TSC_NOT_INCREASED) return "TSC_NOT_INCREASED";
//		    if (val ==IDTEMVData.HASH_INCORRECT) return "HASH_INCORRECT";
//		    if (val ==IDTEMVData.ARC_NOT_PRESENCED) return "ARC_NOT_PRESENCED";
//		    if (val ==IDTEMVData.ARC_INVALID) return "ARC_INVALID";
//		    if (val ==IDTEMVData.COMM_NO_ONLINE) return "COMM_NO_ONLINE";
//		    if (val ==IDTEMVData.TRAN_TYPE_INCORRECT) return "TRAN_TYPE_INCORRECT";
//		    if (val ==IDTEMVData.APP_NO_SUPPORT) return "APP_NO_SUPPORT";
//		    if (val ==IDTEMVData.APP_NOT_SELECT) return "APP_NOT_SELECT";
//		    if (val ==IDTEMVData.LANG_NOT_SELECT) return "LANG_NOT_SELECT";
//		    if (val ==IDTEMVData.TERM_DATA_NOT_PRESENCED) return "TERM_DATA_NOT_PRESENCED";
//		    if (val ==IDTEMVData.CVM_TYPE_UNKNOWN) return "CVM_TYPE_UNKNOWN";
//		    if (val ==IDTEMVData.CVM_AIP_NOT_SUPPORTED) return "CVM_AIP_NOT_SUPPORTED";
//		    if (val ==IDTEMVData.CVM_TAG_8E_MISSING) return "CVM_TAG_8E_MISSING";
//		    if (val ==IDTEMVData.CVM_TAG_8E_FORMAT_ERROR) return "CVM_TAG_8E_FORMAT_ERROR";
//		    if (val ==IDTEMVData.CVM_CODE_IS_NOT_SUPPORTED) return "CVM_CODE_IS_NOT_SUPPORTED";
//		    if (val ==IDTEMVData.CVM_COND_CODE_IS_NOT_SUPPORTED) return "CVM_COND_CODE_IS_NOT_SUPPORTED";
//		    if (val ==IDTEMVData.CVM_NO_MORE) return "CVM_NO_MORE";
//		    if (val ==IDTEMVData.PIN_BYPASSED_BEFORE) return "PIN_BYPASSED_BEFORE";
			
			if (val ==IDTEMVData.APPROVED_OFFLINE) return "APPROVED_OFFLINE";
			if (val ==IDTEMVData.DECLINED_OFFLINE) return "DECLINED_OFFLINE";
			if (val ==IDTEMVData.APPROVED) return "APPROVED";
			if (val ==IDTEMVData.DECLINED) return "DECLINED";
		    if (val ==IDTEMVData.GO_ONLINE) return "GO_ONLINE";
		    if (val ==IDTEMVData.CALL_YOUR_BANK) return "CALL_YOUR_BANK";
		    if (val ==IDTEMVData.NOT_ACCEPTED) return "NOT_ACCEPTED";
		    if (val ==IDTEMVData.USE_MAGSTRIPE) return "USE_MAGSTRIPE";
		    if (val ==IDTEMVData.TIME_OUT) return "TIME_OUT";
		    if (val ==IDTEMVData.START_TRANS_SUCCESS) return "START_TRANS_SUCCESS";
		    if (val ==IDTEMVData.MSR_SUCCESS) return "MSR_SUCCESS";
		    if (val ==IDTEMVData.TRANSACTION_CANCELED) return "TRANSACTION_CANCELED";
            if (val ==IDTEMVData.CTLS_TWO_CARDS) return "CTLS_TWO_CARDS";
            if (val ==IDTEMVData.CTLS_TERMINATE) return "CTLS_TERMINATE";
            if (val ==IDTEMVData.CTLS_TERMINATE_TRY_ANOTHER) return "CTLS_TERMINATE_TRY_ANOTHER";
            if (val ==IDTEMVData.MSR_SWIPE_CAPTURED) return "MSR_SWIPE_CAPTURED";
            if (val ==IDTEMVData.REQUEST_ONLINE_PIN) return "REQUEST_ONLINE_PIN";
            if (val ==IDTEMVData.REQUEST_SIGNATURE) return "REQUEST_SIGNATURE";
            if (val ==IDTEMVData.FALLBACK_TO_CONTACT) return "FALLBACK_TO_CONTACT";
            if (val ==IDTEMVData.FALLBACK_TO_OTHER) return "FALLBACK_TO_OTHER";
            if (val ==IDTEMVData.REVERSAL_REQUIRED) return "REVERSAL_REQUIRED";
            if (val ==IDTEMVData.ADVISE_REQUIRED) return "ADVISE_REQUIRED";
            if (val ==IDTEMVData.NO_ADVISE_REVERSAL_REQUIRED) return "NO_ADVISE_REVERSAL_REQUIRED";
            if (val ==IDTEMVData.UNABLE_TO_REACH_HOST) return "UNABLE_TO_REACH_HOST";
		    if (val ==IDTEMVData.FILE_ARG_INVALID) return "FILE_ARG_INVALID";
		    if (val ==IDTEMVData.FILE_OPEN_FAILED) return "FILE_OPEN_FAILED";
		    if (val ==IDTEMVData.FILE_OPERATION_FAILED) return "FILE_OPERATION_FAILED";
		    if (val ==IDTEMVData.MEMORY_NOT_ENOUGH) return "MEMORY_NOT_ENOUGH";
            if (val ==IDTEMVData.SMARTCARD_OK) return "SMARTCARD_OK";
		    if (val ==IDTEMVData.SMARTCARD_FAIL) return "SMARTCARD_FAIL";
		    if (val ==IDTEMVData.SMARTCARD_INIT_FAILED) return "SMARTCARD_INIT_FAILED";
		    if (val ==IDTEMVData.FALLBACK_SITUATION) return "FALLBACK_SITUATION";
		    if (val ==IDTEMVData.SMARTCARD_ABSENT) return "SMARTCARD_ABSENT";
		    if (val ==IDTEMVData.SMARTCARD_TIMEOUT) return "SMARTCARD_TIMEOUT";
		    if (val ==IDTEMVData.MSR_CARD_ERROR) return "MSR_CARD_ERROR";
		    if (val ==IDTEMVData.PARSING_TAGS_FAILED) return "PARSING_TAGS_FAILED";
		    if (val ==IDTEMVData.CARD_DATA_ELEMENT_DUPLICATE) return "CARD_DATA_ELEMENT_DUPLICATE";
		    if (val ==IDTEMVData.DATA_FORMAT_INCORRECT) return "DATA_FORMAT_INCORRECT";
		    if (val ==IDTEMVData.APP_NO_TERM) return "APP_NO_TERM";
		    if (val ==IDTEMVData.APP_NO_MATCHING) return "APP_NO_MATCHING";
		    if (val ==IDTEMVData.AMANDATORY_OBJECT_MISSING) return "AMANDATORY_OBJECT_MISSING";
		    if (val ==IDTEMVData.APP_SELECTION_RETRY) return "APP_SELECTION_RETRY";
		    if (val ==IDTEMVData.AMOUNT_ERROR_GET) return "AMOUNT_ERROR_GET";
		    if (val ==IDTEMVData.CARD_REJECTED) return "CARD_REJECTED";
		    if (val ==IDTEMVData.AIP_NOT_RECEIVED) return "AIP_NOT_RECEIVED";
		    if (val ==IDTEMVData.AFL_NOT_RECEIVEDE) return "AFL_NOT_RECEIVEDE";
		    if (val ==IDTEMVData.AFL_LEN_OUT_OF_RANGE) return "AFL_LEN_OUT_OF_RANGE";
		    if (val ==IDTEMVData.SFI_OUT_OF_RANGE) return "SFI_OUT_OF_RANGE";
		    if (val ==IDTEMVData.AFL_INCORRECT) return "AFL_INCORRECT";
		    if (val ==IDTEMVData.EXP_DATE_INCORRECT) return "EXP_DATE_INCORRECT";
		    if (val ==IDTEMVData.EFF_DATE_INCORRECT) return "EFF_DATE_INCORRECT";
		    if (val ==IDTEMVData.ISS_COD_TBL_OUT_OF_RANGE) return "ISS_COD_TBL_OUT_OF_RANGE";
		    if (val ==IDTEMVData.CRYPTOGRAM_TYPE_INCORRECT) return "CRYPTOGRAM_TYPE_INCORRECT";
		    if (val ==IDTEMVData.PSE_BY_CARD_NOT_SUPPORTED) return "PSE_BY_CARD_NOT_SUPPORTED";
		    if (val ==IDTEMVData.USER_LANGUAGE_SELECTED) return "USER_LANGUAGE_SELECTED";
		    if (val ==IDTEMVData.SERVICE_NOT_ALLOWED) return "SERVICE_NOT_ALLOWED";
		    if (val ==IDTEMVData.NO_TAG_FOUND) return "NO_TAG_FOUND";
		    if (val ==IDTEMVData.CARD_BLOCKED) return "CARD_BLOCKED";
		    if (val ==IDTEMVData.LEN_INCORRECT) return "LEN_INCORRECT";
		    if (val ==IDTEMVData.CARD_COM_ERROR) return "CARD_COM_ERROR";
		    if (val ==IDTEMVData.TSC_NOT_INCREASED) return "TSC_NOT_INCREASED";
		    if (val ==IDTEMVData.HASH_INCORRECT) return "HASH_INCORRECT";
		    if (val ==IDTEMVData.ARC_NOT_PRESENCED) return "ARC_NOT_PRESENCED";
		    if (val ==IDTEMVData.ARC_INVALID) return "ARC_INVALID";
		    if (val ==IDTEMVData.COMM_NO_ONLINE) return "COMM_NO_ONLINE";
		    if (val ==IDTEMVData.TRAN_TYPE_INCORRECT) return "TRAN_TYPE_INCORRECT";
		    if (val ==IDTEMVData.APP_NO_SUPPORT) return "APP_NO_SUPPORT";
		    if (val ==IDTEMVData.APP_NOT_SELECT) return "APP_NOT_SELECT";
		    if (val ==IDTEMVData.LANG_NOT_SELECT) return "LANG_NOT_SELECT";
		    if (val ==IDTEMVData.TERM_DATA_NOT_PRESENCED) return "TERM_DATA_NOT_PRESENCED";
		    if (val ==IDTEMVData.CVM_TYPE_UNKNOWN) return "CVM_TYPE_UNKNOWN";
		    if (val ==IDTEMVData.CVM_AIP_NOT_SUPPORTED) return "CVM_AIP_NOT_SUPPORTED";
		    if (val ==IDTEMVData.CVM_TAG_8E_MISSING) return "CVM_TAG_8E_MISSING";
		    if (val ==IDTEMVData.CVM_TAG_8E_FORMAT_ERROR) return "CVM_TAG_8E_FORMAT_ERROR";
		    if (val ==IDTEMVData.CVM_CODE_IS_NOT_SUPPORTED) return "CVM_CODE_IS_NOT_SUPPORTED";
		    if (val ==IDTEMVData.CVM_COND_CODE_IS_NOT_SUPPORTED) return "CVM_COND_CODE_IS_NOT_SUPPORTED";
		    if (val ==IDTEMVData.CVM_NO_MORE) return "CVM_NO_MORE";
		    if (val ==IDTEMVData.PIN_BYPASSED_BEFORE) return "PIN_BYPASSED_BEFORE";
            if (val ==IDTEMVData.UNKONWN) return "UNKONWN";
			return "";
		}

		public void msgBatteryLow() {
			// TODO Auto-generated method stub
			
		}
		
		public void ctlsEvent(byte event, byte scheme, byte data){
			
		}

		public void getProfileResult(String output) {
//            if(output.equals("404") || output.equals("403")){
			if(output == null || !output.contains("xml")){
                Toast.makeText(getActivity(), "Profile not found. trying xml", Toast.LENGTH_SHORT).show();
                String filepath = getXMLFileFromRaw();
                if(!isFileExist(filepath)) {
                    filepath = null;
                }
                device.config_setXMLFileNameWithPath(filepath);
                device.config_loadingConfigurationXMLFile(false);

            }else{
                device.device_connectWithProfile(ProfileUtility.JSONtoProfile(output));
                Toast.makeText(getActivity(), "Profile Found", Toast.LENGTH_LONG).show();
            }
			
		}

		public void postProfileResult(String s) {
			Toast.makeText(getActivity(), "Post: "+ s, Toast.LENGTH_SHORT).show();
			
		}
		
		public void onItemSelected(AdapterView<?> parent, View view,
	            int pos, long id) {
	        // An item was selected. You can retrieve the selected item using
	        // parent.getItemAtPosition(pos)
			
			spinnerSelection = pos;
	    }

	    public void onNothingSelected(AdapterView<?> parent) {
	        // Another interface callback
	    }

	    int _mode = 0;
	    byte[] _key = null;
	    byte[] _PAN = null;
	    int _startTO = 0;
	    int _intervalTO = 0;
	    String _language = "";
		public void pinRequest(final int mode, byte[] key, byte[] PAN, int startTO,
				int intervalTO, String language) {
		      
//		      _mode = mode;
//		      _key = key;
//		      _PAN = PAN;
//		      _startTO = startTO;
//		      _intervalTO = intervalTO;
//		      _language = language;
//		      
//	
//				getActivity().runOnUiThread(new Runnable() {			
//					 public void run() {
//						 
//							// get prompts.xml view
//							LayoutInflater li = LayoutInflater.from(getActivity());
//							View promptsView = li.inflate(R.layout.prompts, null);
//
//							AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(
//									getActivity());
//
//							// set prompts.xml to alertdialog builder
//							alertDialogBuilder.setView(promptsView);
//
//							final EditText userInput = (EditText) promptsView
//									.findViewById(R.id.editTextDialogUserInput);
//
//							// set dialog message
//							alertDialogBuilder
//								.setCancelable(false)
//								.setPositiveButton("OK",
//								  new DialogInterface.OnClickListener() {
//								    public void onClick(DialogInterface dialog,int id) {
//									// get user input and set it to result
//									// edit text
//									String thepin = userInput.getText().toString();
//								      byte[] pin2 = null;
//								      try {
//										pin2 = thepin.getBytes("UTF-8");
//									} catch (UnsupportedEncodingException e) {
//										// TODO Auto-generated catch block
//										e.printStackTrace();
//									}
//								      device.emv_callbackResponsePIN(mode,null,pin2);
//								    }
//								  })
//								.setNegativeButton("Cancel",
//								  new DialogInterface.OnClickListener() {
//								    public void onClick(DialogInterface dialog,int id) {
//									dialog.cancel();
//									 device.emv_callbackResponsePIN(0,null,null);
//								    }
//								  });
//
//							// create alert dialog
//							AlertDialog alertDialog = alertDialogBuilder.create();
//
//							// show it
//							alertDialog.show();
//
//					 }
//				});
//			
		}

	}

}
